uniform sampler2D CC_Texture0;
varying vec2 v_texCoords;
varying vec2 v_lensPosition;
varying float v_strength;
varying float v_lensSize;

void main()
{
    vec2 p = v_texCoords.xy;
    vec2 m = v_lensPosition;
    vec2 d = p - m;
    float s = 1.0 - v_strength;
    float r = sqrt(dot(d, d));
    float power = ( 2.0 * 3.141592 / (2.0 * sqrt(dot(m, m))) ) * (v_lensSize - 0.5);
    float bind;
    if (power > 0.0)
    {
        bind = sqrt(dot(m, m));
    }
    else
    {
        bind = m.y;
    }
    
    vec2 uv;
    vec2 uv2;
    if (power > 0.0)//fisheye
    {
        uv = m + normalize(d) * tan(r * power) * bind / tan( bind * power);
        uv2 = mix(uv, p, vec2(s, s));
    }
    else if (power < 0.0)//antifisheye
    {
        uv = m + normalize(d) * atan(r * -power * 10.0) * bind / atan(-power * bind * 10.0);
        uv2 = mix(uv, p, vec2(s, s));
    }
    else
        uv2 = p;
    
    vec4 col = texture2D(CC_Texture0, vec2(uv2.x, uv2.y));
    gl_FragColor = col;
}