#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec4 u_tintMultiplier;
uniform vec4 u_tintOffset;

void main() 
{
    const float kMinimalAlphaAllowed = 0.001;
	vec4 color = texture2D(u_texture, v_texCoord);
    color.a = max(color.a, kMinimalAlphaAllowed);   // to avoid division by 0
	color = vec4(color.r / color.a, color.g / color.a, color.b / color.a, color.a); //color without premultiplied alpha
	color = color * u_tintMultiplier + u_tintOffset;								//apply the tint
	color = vec4(color.r * color.a, color.g * color.a, color.b * color.a, color.a); //back to premultiplied alpha
	
	gl_FragColor = color;
}
