uniform sampler2D CC_Texture0;
varying vec2 v_texCoords;
varying vec2 v_lensPosition;
varying float v_lensSize;
varying float v_strength;

void main()
{
    vec2 p = v_texCoords;
    vec2 m = v_lensPosition;
    vec2 d = p - m;
    float s = 1.0 - v_strength;
    float r = sqrt(dot(d, d));
    vec2 uv;
    vec4 col;
    if (r >= v_lensSize)
    {
        uv = p;
        col = texture2D(CC_Texture0, vec2(uv.x, uv.y));
    }
    else if (r < v_lensSize)
    {
        uv = m + d * r; // a.k.a. m + normalize(d) * r * r
        vec2 uv2 = mix(uv, p, vec2(s, s));
        
        col = texture2D(CC_Texture0, vec2(uv2.x, uv2.y));
    }
    gl_FragColor = col;
}