#ifdef GL_ES
    precision highp float;
#endif

uniform sampler2D CC_Texture0;
varying vec2 v_texCoords;
varying vec2 v_resolution;

varying float v_globalTime;
varying float v_amplitude;
varying float v_speed;
varying float v_frequency;

vec2 shift(vec2 p) {
    vec2 f = v_frequency * (p + v_globalTime*v_speed);
    vec2 q = cos( vec2(
                       cos(f.x-f.y)*cos(f.y),
                       sin(f.x+f.y)*sin(f.y) ) );
    return q;
}

void main()
{
    vec2 r = v_texCoords;
    vec2 p = shift( r );
    vec2 q = shift(r + 1.0);
    float amplitude = v_amplitude / v_resolution.x;
    vec2 s = r + amplitude * (p - q);
    gl_FragColor = texture2D(CC_Texture0, s);
}